/*
AutoHotkey-Kalender
*/
#NoEnv ; Avoids checking empty variables to see if they are environment variables
#SingleInstance, Force
#NoTrayIcon
SendMode, Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir, %A_ScriptDir%  ; Ensures a consistent starting directory.
Process, Priority,, High ; PID-or-Name: if blank the priority of the script itself
SetBatchLines, -1 ; run at maximum speed; default is 10ms
ListLines, Off ; "ListLines Off" may improve performance by a few percent
ScriptName = AutoHotkey-Kalender
ScriptVersion = 3.2
ScriptDate = 27.11.15
;------------------------------------------------------------------------------
If !A_IsAdmin
  {
  Run *RunAs "%A_ScriptFullPath%",, UseErrorLevel ; Don't display dialog if it fails. v1.0.92.01+
  If ErrorLevel = ERROR
    MsgBox, 48, %ScriptName%, Ohne Administratorrechte kann das Datum nicht an andere Fenster gesendet werden!
  Else
    ExitApp
  }
;------------------------------------------------------------------------------
TheTimeBefore = 0 ; for DoubleClick detection
Ptr := A_PtrSize ? "Ptr" : "UInt"  ; for compatibility with older AHK-Versions
Menu, Tray, Icon, %A_WinDir%\System32\shell32.dll, 138
IfEqual, 1, /QuickKey ; The script sees incoming parameters as the variables %1%, %2%, and so on.
  QuickKey := true
;-----------------------------------------------------------------------------------------
IfNotExist, Kalender.ini
  {
  FileAppend,
    (
[Kalender]
Format = 2
    ), Kalender.ini
  If !QuickKey
    MsgBox, 0, Hinweise zu %ScriptName%, Sie knnen eine Tastenkombination festlegen, mit der Sie`nden Kalender systemweit aufrufen knnen, wenn das Pro-`ngramm ins Tray minimiert wurde: s. Ansicht|Einstellungen.`n`nVoreingestellt ist folgender Hotkey: <Strg+Windows+K>.`n`nApropos: Das Programm fragt nach Administratorrechten,`num Datumsangaben an andere Fenster schicken zu drfen.
  }
IniRead, MinToTray, Kalender.ini, Kalender, MinToTray, 1
MinToTray := QuickKey ? 0 : MinToTray
IniRead, KalenderHotkey, Kalender.ini, Kalender, KalenderHotkey, #^k
IniRead, datFormat, Kalender.ini, Kalender, DatFormat, 2
IniRead, xPos, Kalender.ini, Kalender, WinPosX, center
IniRead, yPos, Kalender.ini, Kalender, WinPosY, center
IniRead, MonthView, Kalender.ini, Kalender, MonthView, 1
IniRead, ColorScheme, Kalender.ini, Kalender, ColorScheme, 1
xPos := !xPos ? 1 : xPos
ypos := !yPos ? 1 : yPos
If ColorScheme = 2 ; Windows klassisch
  { ; BGR format!
    LightMonthCal = 0xFFEFE9 ; 0xF5F5F5 ; 0xFDEEE4
    DarkMonthCal = 0x6A240A ; 800000
    DaysMonthCal = 0x000000
    HeadMonthCal = 0xFFFFFF
    TrailMonthCal = 0x808080 ; Tage auerhalb des Monats
  }
Else If ColorScheme = 3 ; Yellow
  { ; BGR format!
    LightMonthCal = 0xECFFFF ; KalenderBackground
    DarkMonthCal = 0x00AEDE
    DaysMonthCal = 0x000000
    HeadMonthCal = 0xFFFFFF
    TrailMonthCal = 0x808080 ; Tage auerhalb des Monats
  }
Else If ColorScheme = 4 ; Black beauty
  { ; BGR format!
    LightMonthCal = 0xFFFFFF ; Achtung fr Progress wird statt RGB BGR benutzt!
    DarkMonthCal = 0x333333
    DaysMonthCal = 0x000000
    HeadMonthCal = 0xCCCCCC ; darf nicht wei sein!
    TrailMonthCal = 0x808080 ; Tage auerhalb des Monats
  }
Else
  { ; BGR format!
    LightMonthCal = 0xEDF0E5 ; Achtung fr Progress wird statt RGB BGR benutzt!
    DarkMonthCal = 0x526E00 ; dunkelgrn
    DaysMonthCal = 0x000000 ; schwarz
    HeadMonthCal = 0xCCCCCC ; darf nicht wei sein!
    TrailMonthCal = 0x808080 ; Tage auerhalb des Monats
  }
    F0 = d.M.                     ; 1.1.
    F1 = d.M.yy                   ; 1.1.11
    F2 = dd.MM.yy                 ; 01.01.11
    F3 = d.M.yyyy                 ; 1.11.2011
    F4 = dd.MM.yyyy               ; 01.01.2011
    F5 = d. MMMM yyyy             ; 1. Januar 2011
    F6 = ddd., d.M.yy 						; So., 1.1.12
    F7 = dddd, 'den' d. MMMM yyyy ; Sonntag, den 1. Januar 2012
    F := F2 ; (Default)
    If datFormat = 0
      F := F0
    If datFormat = 1
      F := F1
    If datFormat = 3
      F := F3
    If datFormat = 4
      F := F4
    If datFormat = 5
      F := F5
    If datFormat = 6
      F := F6
    If datFormat = 7
      F := F6
    FormatTime, Heute,, %F%
If (ADat="")
    BDat=%Heute%

varMenuEnter = Beenden und Datum bertragen`tEingabetaste
varMenuSpace = Datumsformat ndern`tLeertaste/F2
varMenuOne   = &1 Monat`tF3
varMenuThree = &3 Monate`tF3
varMenuDiff  = &Datumsberechnung`tF4
Menu, FileMenu, Add, %varMenuEnter%, CloseCalendar
Menu, FileMenu, Add
If !QuickKey
  Menu, FileMenu, Add, &Schlieen`tEsc, GUIClose ; versetzt Escape in Funktion, auch ohne GUIEscape!
Menu, FileMenu, Add, &Beenden, CloseApp
Menu, MyMenuBar, Add, &Datei, :FileMenu
Menu, EditMenu, Add, %varMenuSpace%, GuiMenu
Menu, EditMenu, Add
Menu, EditMenu, Add, Gehe zu Heute`tF5, GoToNow
Menu, MyMenuBar, Add, &Bearbeiten, :EditMenu
Menu, ViewMenu, Add, %varMenuOne%, MonthView1
Menu, ViewMenu, Add, %varMenuThree%, MonthView3
Menu, ViewMenu, Add, %varMenuDiff%, DayDiff
Menu, ViewMenu, Add
Menu, ViewMenu, Add, &Einstellungen..., Options
If !QuickKey
  Menu, ViewMenu, Add, &Autostart..., TaskSchd
Menu, MyMenuBar, Add, &Ansicht, :ViewMenu
Menu, HelpMenu, Add, &Kalender-Hilfe`tF1, MsgBoxHelp
Menu, HelpMenu, Add, Kurz&befehle, MsgBoxKeys
Menu, HelpMenu, Add, &Webseite, Website
Menu, HelpMenu, Add, &Info, About
Menu, MyMenuBar, Add, &Hilfe, :HelpMenu

MenuMonthView1 = &Monatskalender
MenuMonthView3 = &3-Monatsansicht
MenuMonthView4 = &Datumsrechner
Menu, Tray, NoStandard
Menu, Tray, Tip, %ScriptName%
Menu, Tray, Add, &Info ber..., About
Menu, Tray, Add, &Einstellungen..., Options
If (!A_IsCompiled)
  Menu, Tray, Add, Skript &bearbeiten, ScriptEdit
Menu, Tray, Add
Menu, Tray, Add, %MenuMonthView1%, MonthView1
Menu, Tray, Add, %MenuMonthView3%, MonthView3
Menu, Tray, Add, %MenuMonthView4%, DayDiff
Menu, Tray, Add
Menu, Tray, Add, &Beenden, CloseApp
Menu, Tray, Click, 1
Menu, Tray, Tip, %ScriptName%
If MinToTray
  Menu, Tray, Icon
If MonthView = 3
  GoSub, MonthView3
Else If MonthView = 4
  GoSub, DayDiff
Else
  GoSub, MonthView1
Return
;-----------------------------------------------------------------------------------------

ScriptEdit:
  Edit
Return

TaskSchd:
  MsgBox, 262148, Automatischer Programmstart - %ScriptName%, Wenn Sie das Programm regelmig nutzen mchten, sollten`nSie es ber die Aufgabenplanung automatisch starten lassen`n(Bei Anmeldung starten, Mit hchsten Berechtigungen...).`n`nMchten Sie jetzt die Windows-Aufgabenplanung ffnen?
  IfMsgBox, Yes
    {
    Run, taskschd.msc,, UseErrorLevel
    If ErrorLevel = Error
      MsgBox,16, %ScriptName% %ScriptVersion%, Die Aufgabenplanung kann nicht geffnet werden!
    }
Return

Website:
  Run, www.ophthalmostar.de/autohotkey.htm#Kalender
  If ErrorLevel = ERROR
    MsgBox, 62160, %ScriptName%, Die Webseite konnte nicht geffnet werden.
Return

MonthView1:
  IfWinExist, ahk_id %hw_Kalender%
    {
    WinGetPos, xPos, yPos
    Gui, Destroy
    IfEqual, MonthView, 1, Return ; Show/Hide
    }
  Menu, Tray, Default, %MenuMonthView1%
  If (MinToTray && KalenderHotkey <> "")
    {
    Hotkey, %KalenderHotkey%, MonthView1, UseErrorLevel
    If ErrorLevel in 5,6
      MsgBox, 64, %ScriptName%, Der Hotkey existiert nicht.
    }
  Gui, +LastFound +AlwaysOnTop -MinimizeBox -MaximizeBox ; +E0x40000 ; +ToolWindow
  hw_Kalender := WinExist() ; belongs to the line before
  Gui, font, norm s9, MS Sans Serif
  Gui, Menu, MyMenuBar
  Gui, Add, Radio, x5 y5 w70 h20 vMonthView1 gMonthView1 +0x1000 Checked, 1 Monat
  Gui, Add, Radio, x+ w70 h20 gMonthView3 +0x1000, 3 Monate
  Gui, Add, Radio, x+ w70 h20 gDayDiff +0x1000, Rechner ;   #   &  
  Gui, Add, MonthCal, x5 y+5 w210 h170 gMCalRoutine vADat Multi 4 Border AltSubmit, %ADat%
  Gui, Add, Button, Default w180 h22 x5 y+5 gCloseCalendar, % TrimToWidth(BDat, 170)
  Gui, Add, Button, w30 h22 x+ gGuiMenu, # ;    #   &  
  Gui, Show, Hide x%xPos% y%yPos% w220, %ScriptName%
  MonthView = 1
  SendMessage, 0x100A, 0, %LightMonthCal%, SysMonthCal321 ; Seitenstreifen
  SendMessage, 0x100A, 1, %DaysMonthCal%, SysMonthCal321 ; Tage, Heute
  SendMessage, 0x100A, 2, %DarkMonthCal%, SysMonthCal321 ; Wochen, Kopfhintergrund
  SendMessage, 0x100A, 3, %HeadMonthCal%, SysMonthCal321 ; Kopftext (M/J/H)
  SendMessage, 0x100A, 4, %LightMonthCal%, SysMonthCal321 ; Kalenderhintergrund
  SendMessage, 0x100A, 5, %TrailMonthCal%, SysMonthCal321 ; Tage auerhalb des Monats
/*
0: background color displayed between months
1: background color displayed within the month
2: color used to display text within a month
3: background color displayed in the calendar's title
4: color used to display text within the calendar's title
5: color used to display days from the previous and following months
*/

	WinGetPos, Win_X, Win_Y, Win_Width, Win_Height
  If (Win_X < 0)
      Win_X := 0
  If (Win_Y < 0)
      Win_Y := 0
  If (Win_X > A_ScreenWidth - Win_Width)
      Win_X := A_ScreenWidth - Win_Width
  If (Win_Y > A_ScreenHeight - Win_Height)
      Win_Y := A_ScreenHeight - Win_Height
	WinMove, %Win_X%, %Win_Y%
	WinShow
	WinActivate

  GroupAdd, Kalender_ID, ahk_id %hw_Kalender%
  Menu, EditMenu, Enable, %varMenuSpace%
  Menu, FileMenu, Enable, %varMenuEnter%
  Menu, ViewMenu, Disable, %varMenuOne%
  Menu, ViewMenu, Enable, %varMenuThree%
  Menu, ViewMenu, Enable, %varMenuDiff%
Return

MonthView3:
  IfWinExist, ahk_id %hw_Kalender%
    {
    WinGetPos, xPos, yPos
    Gui, Destroy
    IfEqual, MonthView, 3, Return ; Show/Hide
    }
  If (MinToTray && KalenderHotkey <> "")
    {
    Hotkey, %KalenderHotkey%, MonthView3, UseErrorLevel
    If ErrorLevel in 5,6
      MsgBox, 64, %ScriptName%, Der Hotkey existiert nicht.
    }
  Menu, Tray, Default, %MenuMonthView3%
  Gui, +LastFound +AlwaysOnTop -MinimizeBox -MaximizeBox
  hw_Kalender := WinExist() ; belongs to the line before
  Gui, font, norm s9, MS Sans Serif
  Gui, Menu, MyMenuBar
  Gui, Add, Radio, x5 y5 w70 h20 vMonthView1 gMonthView1 +0x1000, 1 Monat
  Gui, Add, Radio, x+ w70 h20 gMonthView3 +0x1000 Checked, 3 Monate
  Gui, Add, Radio, x+ w70 h20 gDayDiff +0x1000, Rechner ;   #   &  
  guiHeight = 454
  Gui, Add, MonthCal, x5 y+5 w210 h454 gMCalRoutine vADat Multi 4 R3 Border AltSubmit, %ADat%
  Gui, Add, Button, Default w180 h22 x5 y+5 gCloseCalendar, % TrimToWidth(BDat, 170)
  Gui, Add, Button, w30 h22 x+ gGuiMenu, # ;    #   &  
  Gui, Show, Hide x%xPos% y%yPos% w220, %ScriptName%
  MonthView = 3
  SendMessage, 0x100A, 0, %LightMonthCal%, SysMonthCal321 ; Seitenstreifen
  SendMessage, 0x100A, 1, %DaysMonthCal%, SysMonthCal321 ; Tage, Heute
  SendMessage, 0x100A, 2, %DarkMonthCal%, SysMonthCal321 ; Wochen, Kopfhintergrund
  SendMessage, 0x100A, 3, %HeadMonthCal%, SysMonthCal321 ; Kopftext (M/J/H)
  SendMessage, 0x100A, 4, %LightMonthCal%, SysMonthCal321 ; Kalenderhintergrund
  SendMessage, 0x100A, 5, %TrailMonthCal%, SysMonthCal321 ; Tage auerhalb des Monats

	WinGetPos, Win_X, Win_Y, Win_Width, Win_Height
  If (Win_X < 0)
      Win_X := 0
  If (Win_Y < 0)
      Win_Y := 0
  If (Win_X > A_ScreenWidth - Win_Width)
      Win_X := A_ScreenWidth - Win_Width
  If (Win_Y > A_ScreenHeight - Win_Height)
      Win_Y := A_ScreenHeight - Win_Height
	WinMove, %Win_X%, %Win_Y%
	WinShow
	WinActivate

  If ADat =
    {
      ADat := A_MM - 1
      If ADat = 0
          ADat := 12
      Else If ADat < 10
          ADat := "0" . ADat
      ADat := A_YYYY . ADat . "010000"
      GuiControl,, SysMonthCal321, %ADat%
      GuiControl,, SysMonthCal321, %A_Now%
      ADat =
    }
  GroupAdd, Kalender_ID, ahk_id %hw_Kalender%
  Menu, EditMenu, Enable, %varMenuSpace%
  Menu, FileMenu, Enable, %varMenuEnter%
  Menu, ViewMenu, Enable, %varMenuOne%
  Menu, ViewMenu, Disable, %varMenuThree%
  Menu, ViewMenu, Enable, %varMenuDiff%
Return

DayDiff:
  IfWinExist, ahk_id %hw_Kalender%
    {
    WinGetPos, xPos, yPos
    Gui, Destroy
    IfEqual, MonthView, 4, Return ; Show/Hide
    }
  If (MinToTray && KalenderHotkey <> "")
    {
    Hotkey, %KalenderHotkey%, DayDiff, UseErrorLevel
    If ErrorLevel in 5,6
      MsgBox, 64, %ScriptName%, Der Hotkey existiert nicht.
    }
  Menu, Tray, Default, %MenuMonthView4%
  Gui, +LastFound +AlwaysOnTop -MinimizeBox -MaximizeBox
  hw_Kalender := WinExist() ; belongs to the line before
  Gui, font, norm s9, MS Sans Serif
  Gui, Menu, MyMenuBar
  Gui, Add, Radio, x5 y5 w70 h20 vMonthView1 gMonthView1 +0x1000, 1 Monat
  Gui, Add, Radio, x+ w70 h20 gMonthView3 +0x1000, 3 Monate
  Gui, Add, Radio, x+ w70 h20 gDayDiff +0x1000 Checked, Rechner ;   #   &  
  If ADat =
      ADat := A_Now
  StringSplit, VonBis, ADat, -
  Gui, Margin, 5  ; left/right magin
  Gui, Add, Text, xm yp+35, Was mchten Sie berechnen?
  groupIndex = 1
  optDayCalc1 = Differenz zwischen 2 Daten
  optDayCalc2 = Tage addieren/subtrahieren
  Gui, Add, Radio, xm yp+20 w180 h25 Checked%groupIndex% vgroupIndex gCalcSelection, %optDayCalc1%
  Gui, Add, Radio, xm yp+21 w180 h25 gCalcSelection, %optDayCalc2%
  Gui, Add, Text, xm yp+30, Geben Sie Ihre Daten ein:
  Gui, Add, DateTime, xm yp+21 w100 vstartDate gsub_twoDates Range16010101-21000101
  startDate_TT := "1.1.1601 bis 31.12.2099"
  Gui, Add, Edit, xm+110 yp w100 vdiffDays gsub_diffDays Limit8 ; -182.255; Option Number verhindert Minuszeichen
  Gui, Add, UpDown, vdiffDays_ud Range-182255-182255, 0 ; 0x80 => omit the thousands separator
  diffDays_TT := "-182255 bis 182255"
  GuiControl, Hide, diffDays
  GuiControl, Hide, diffDays_ud
  Gui, Add, DateTime,xm+110 yp w100 vendDate gsub_twoDates Right Range16010101-21000101
  endDate_TT := "1.1.1601 bis 31.12.2099"
  Gui, Add, Text, xm yp+35 vstrErgebnis, Unterschied in Tagen:
  Gui, Add, Edit, xm yp+21 w210 r4 vstatusRes HwndResultEditID
  PostMessage, 0xD3, 0x3, 131074,, ahk_id %ResultEditID% ; EC_RIGHT- & LEFTMARGIN, 65536*2+2
  Gui, Show, Hide x%xPos% y%yPos% w220, %ScriptName%
  MonthView = 4
  GuiControl,, startDate, %VonBis1%
  GuiControl,, endDate, %VonBis2%
  OnMessage(0x133, "WM_CTLCOLOREDIT0") ; WM_CTLCOLOREDIT = 0x133
  OnMessage(0x200, "WM_MOUSEMOVE0")
  SendMessage, 0x1006, 0, %LightMonthCal%, SysDateTimePick321 ; Seitenstreifen
  SendMessage, 0x1006, 0, %LightMonthCal%, SysDateTimePick322 ; Seitenstreifen
  SendMessage, 0x1006, 1, %DaysMonthCal%, SysDateTimePick321 ; Tage, Heute
  SendMessage, 0x1006, 1, %DaysMonthCal%, SysDateTimePick322 ; Tage, Heute
  SendMessage, 0x1006, 2, %DarkMonthCal%, SysDateTimePick321 ; Wochen, Kopfhintergrund
  SendMessage, 0x1006, 2, %DarkMonthCal%, SysDateTimePick322 ; Wochen, Kopfhintergrund
  SendMessage, 0x1006, 3, %HeadMonthCal%, SysDateTimePick321 ; Kopftext (M/J/H)
  SendMessage, 0x1006, 3, %HeadMonthCal%, SysDateTimePick322 ; Kopftext (M/J/H)
  SendMessage, 0x1006, 4, %LightMonthCal%, SysDateTimePick321 ; Kalenderhintergrund
  SendMessage, 0x1006, 4, %LightMonthCal%, SysDateTimePick322 ; Kalenderhintergrund
  SendMessage, 0x1006, 5, %TrailMonthCal%, SysDateTimePick321 ; Tage auerhalb des Monats
  SendMessage, 0x1006, 5, %TrailMonthCal%, SysDateTimePick322 ; Tage auerhalb des Monats
  SendMessage, 0x1006, 6, %TrailMonthCal%, SysDateTimePick321 ; Tage auerhalb des Monats
  SendMessage, 0x1006, 7, %TrailMonthCal%, SysDateTimePick321 ; Tage auerhalb des Monats
  SendMessage, 0x1006, 8, %TrailMonthCal%, SysDateTimePick321 ; Tage auerhalb des Monats
  SendMessage, 0x1006, 9, %TrailMonthCal%, SysDateTimePick321 ; Tage auerhalb des Monats
	WinGetPos, Win_X, Win_Y, Win_Width, Win_Height
  If (Win_X < 0)
      Win_X := 0
  If (Win_Y < 0)
      Win_Y := 0
  If (Win_X > A_ScreenWidth - Win_Width)
      Win_X := A_ScreenWidth - Win_Width
  If (Win_Y > A_ScreenHeight - Win_Height)
      Win_Y := A_ScreenHeight - Win_Height
	WinMove, %Win_X%, %Win_Y%
	WinShow
	WinActivate
  Menu, EditMenu, Disable, %varMenuSpace%
  Menu, FileMenu, Disable, %varMenuEnter%
  Menu, ViewMenu, Enable, %varMenuOne%
  Menu, ViewMenu, Enable, %varMenuThree%
  Menu, ViewMenu, Disable, %varMenuDiff%
  GroupAdd, DayDiff_ID, ahk_id %hw_Kalender%
  GoSub, sub_twoDates
Return

#IfWinActive, ahk_group Kalender_ID
F1::
GoSub, MsgBoxHelp
Return
F2::
  GoSub, GuiMenu
Return
F3::
  If MonthView = 1
      GoSub, MonthView3
  Else
      GoSub, MonthView1
Return
F4::
  GoSub, DayDiff
Return
Home::
F5::
  GoSub, GoToNow
Return
MButton::
Space::
  GuiControlGet, ADat
  StringSplit, VonBis, ADat, -
  GoSub, SplitDate
  FormatTime, numDay1, %ADat1%, d  ; Day without leading zero (1  31)
  FormatTime, numMonth1, %ADat1%, M  ; Month without leading zero (1  12)
  If (numDay1 > 9 and numMonth1 > 9 and (datformat = 1 or datformat = 3))
    datformat ++  ; 31.12.12 und 31.12.2012 wrden sonst doppelt angezeigt
  If datFormat = 0
      F := F1
  If datFormat = 1
      F := F2
  If datFormat = 2
      F := F3
  If datFormat = 3
      F := F4
  If datFormat = 4
      F := F5
  If datFormat = 5
      F := F6
  If datFormat = 6
      F := F7
  If datFormat = 7
      F := F0
  datFormat := datFormat = 7 ? 0 : datFormat + 1
  Gosub, UpdateFormat
Return
+MButton::
+Space::
  GuiControlGet, ADat
  StringSplit, VonBis, ADat, -
  GoSub, SplitDate
  FormatTime, numDay1, %ADat1%, d  ; Day without leading zero (1  31)
  FormatTime, numMonth1, %ADat1%, M  ; Month without leading zero (1  12)
  If (numDay1 > 9 and numMonth1 > 9 and (datformat = 2 or datformat = 4))
    datformat --  ; 31.12.12 und 31.12.2012 wrden sonst doppelt angezeigt
  If datFormat = 0
      F := F6
  If datFormat = 1
      F := F0
  If datFormat = 2
      F := F1
  If datFormat = 3
      F := F2
  If datFormat = 4
      F := F3
  If datFormat = 5
      F := F4
  If datFormat = 6
      F := F5
  If datFormat = 7
      F := F6
  datFormat := datFormat = 0 ? 7 : datFormat - 1
  Gosub, UpdateFormat
Return
+Right::
+Left::
+Down::
+Up::
+WheelRight::
+WheelLeft::
+WheelDown::
+WheelUp::
  GoSub, SplitDate
  If (A_ThisHotkey = "+Right" || A_ThisHotkey = "+WheelRight")
    EnvAdd, ADat2, +1, Days
  If (A_ThisHotkey = "+Left" || A_ThisHotkey = "+WheelLeft")
    EnvAdd, ADat2, -1, Days
  If (A_ThisHotkey = "+Down" || A_ThisHotkey = "+WheelDown")
    EnvAdd, ADat2, +7, Days
  If (A_ThisHotkey = "+Up" || A_ThisHotkey = "+WheelUp")
    EnvAdd, ADat2, -7, Days
  ADat := ADat1 "-"  ADat2
  GuiControl,, SysMonthCal321, %ADat%
  GoSub, MCalRoutine
Return
Right::
WheelRight::
  GoSub, SplitDate
  ADat1 += 1, Days
  ADat2 := ADat1
  ADat := ADat1 "-"  ADat2
  GuiControl,, SysMonthCal321, %ADat%
  GoSub, MCalRoutine
Return
Left::
WheelLeft::
  GoSub, SplitDate
  EnvAdd, ADat1, -1, Days
  ADat2 := ADat1
  ADat := ADat1 "-"  ADat2
  GuiControl,, SysMonthCal321, %ADat%
  GoSub, MCalRoutine
Return
Up::
WheelUp::
  GoSub, SplitDate
  EnvAdd, ADat1, -7, Days
  ADat2 := ADat1
  ADat := ADat1 "-"  ADat2
  GuiControl,, SysMonthCal321, %ADat%
  GoSub, MCalRoutine
Return
Down::
WheelDown::
  GoSub, SplitDate
  ADat1 += 7, Days
  ADat2 := ADat1
  ADat := ADat1 "-"  ADat2
  GuiControl,, SysMonthCal321, %ADat%
  GoSub, MCalRoutine
Return
PgUp::
  GoSub, SplitDate
  Monat1 -= 1
  If Monat1 = 0
    {
      Monat1 = 12
      Jahr1 -= 1
    }
  If Monat1 < 10
      Monat1 := "0" . Monat1
  ADat := Jahr1 . Monat1 . SubStr(ADat1, 7, 2)
  GuiControl,, SysMonthCal321, %ADat%
  GoSub, MCalRoutine
Return
PgDn::
  GoSub, SplitDate
  Monat1 += 1
  If Monat1 = 13
    {
      Monat1 = 1
      Jahr1 += 1
    }
  If Monat1 < 10
      Monat1 := "0" . Monat1
  ADat := Jahr1 . Monat1 . SubStr(ADat1, 7, 2)
  GuiControl,, SysMonthCal321, %ADat%
  GoSub, MCalRoutine
Return
+PgDn::
+PgUp::
  GoSub, SplitDate
  If (A_ThisHotkey = "+PgDn")
    EnvAdd, ADat2, +28, Days
  If (A_ThisHotkey = "+PgUp")
    EnvAdd, ADat2, -28, Days
  ADat := ADat1 "-"  ADat2
  GuiControl,, SysMonthCal321, %ADat%
  GoSub, MCalRoutine
Return

#IfWinActive, ahk_group DayDiff_ID
F1::
GoSub, MsgBoxHelp
Return
F2::
  GuiControl,, % groupIndex = 1 ? optDayCalc2 : optDayCalc1, 1
  groupIndex :=  groupIndex = 1 ? 2 : 1
  GoSub, CalcSelection
Return
F3::
  GoSub, MonthView1
Return
Home::
F5::
  GoSub, GoToNow
Return
PgUp::
  GuiControlGet, focusControl, FocusV
  If focusControl = diffDays
    {
    GuiControlGet, diffDays
    StringReplace, diffDays, diffDays, .,, All
    GuiControl,, diffDays, % ThousandsSep(diffDays + 7)
    If groupIndex = 1
      GoSub, sub_twoDates
    Else
      GoSub, sub_diffDays
    }
Return
PgDn::
  GuiControlGet, focusControl, FocusV
  If focusControl = diffDays
    {
    GuiControlGet, diffDays
    StringReplace, diffDays, diffDays, .,, All
    GuiControl,, diffDays, % ThousandsSep(diffDays - 7)
    If groupIndex = 1
      GoSub, sub_twoDates
    Else
      GoSub, sub_diffDays
    }
Return
~WheelUp::
  ControlGetFocus, focusControl, A
  If InStr(focusControl, "SysDateTimePick32")
    Send, {Up}
Return
~WheelDown::
  ControlGetFocus, focusControl, A
  If InStr(focusControl, "SysDateTimePick32")
    Send, {Down}
Return
#IfWinActive

SplitDate:
  NoMouseClick = 1
  If ADat =
      ADat := SubStr(A_Now,1, 8) . "-" . SubStr(A_Now,1, 8)
  StringSplit, ADat, ADat, -
  Jahr1 := SubStr(ADat1, 1, 4)
  Jahr2 := SubStr(ADat2, 1, 4)
  Monat1 := SubStr(ADat1, 5, 2)
  Monat2 := SubStr(ADat2, 5, 2)
  Tag1 := SubStr(ADat1, 7, 2)
  Tag2 := SubStr(ADat2, 7, 2)
Return

GoToNow:
  GuiControlGet, focusControl, FocusV
  If MonthView = 4 ;  WinExist("ahk_group Kalender_ID")
    {
    If focusControl = endDate
      {
      GuiControl,, endDate, %A_Now%
      GoSub, sub_twoDates
      }
    Else
      {
      GuiControl,, startDate, %A_Now%
      If groupIndex = 1
        GoSub, sub_twoDates
      Else
        GoSub, sub_diffDays
      }
    }
  Else ; If MonthView <> 4 ;  WinExist("ahk_group Kalender_ID")
    {
    GuiControl,, SysMonthCal321, %A_Now%
    BDat = %A_Now%
    FormatTime, BDat, %BDat%, %F%
    ControlSetText, Button4, % TrimToWidth(BDat, 170)
    }
Return

MsgBoxHelp:
If MonthView = 4
  KalenderHilfe =
    (
In der Ansicht Datumsberechnung (Tage) knnen Sie den Unter-
schied zwischen zwei Daten berechnen oder zu einem bestimmten
Datum Tage Addieren oder Subtrahieren.

Die Berechnungsart knnen Sie nicht nur durch das Anklicken mit
der Maus ndern, sondern auch durch das Drcken der F2-Taste.

Wenn sich der Cursor in einem Datumfeld befindet, knnen Sie
mit der F5-Taste zu dem heutigen Datum springen.

Befindet sich der Cursor in dem Feld fr die Addition/Subtraktion
von Tagen, knnen Sie mit der Bild-auf- bzw. Bild-ab-Taste sieben
Tage `(eine ganze Woche`) addieren oder subtrahieren.

Grundstzlich knnen nur Daten zwischen dem 1.1.1601 und dem
31.12.2099 eingegeben beziehungsweise berechnet werden.
    )
Else
  KalenderHilfe =
    (
Sie knnen ein einzelnes Datum oder einen Bereich auswhlen
und das Datum in andere Anwendungen bernehmen.

Mit den Pfeiltasten kann innerhalb des des Kalenders navigiert
werden. Drcken der Leertaste ndert das Datumsformat.

Um einen Bereich zu markieren, ziehen Sie mit gedrckter Maus-
taste ber die Tagesdaten oder fhren Sie den zweiten Maus-
klick mit gedrckter Shift-Taste aus.

Das Datum wird automatisch in die Zwischenablage bernommen.
Es kann durch Strg-V andernorts eingefgt werden.

Fr groe Zeitsprnge klicken Sie bitte auf den Monatsnamen.
Die Ansicht wechselt dann zu Monatsnamen bzw. Jahreszahlen.

Klicken Sie auf <Heute>, um zum aktuellen Datum zu springen.
    )
  Gui, +OwnDialogs ; Force the user to close the MsgBox before returning to the main window.
  MsgBox, 262144, Kalender-Hilfe, %KalenderHilfe%
Return

MsgBoxKeys:
  If MonthView = 4
    HotkeyHilfe =
    (
F1 `t`tHilfe
F2 `t`tBerechnungart ndern
F3 `t`tAnsicht wechseln
F4 `t`tDatumsberechnung
Escapetaste `tSchlieen

In Datumsfeldern:
Pfeil auf `t`tEinheit erhhen
Pfeil ab  `t`tEinheit vermindern
Mausrad auf `teine Einheit zurck
Mausrad ab  `teine Einheit weiter

Zustzlich im Additions-/Subtraktionsfeld:
Bild auf `t`tWoche addieren
Bild ab `t`tWoche subtrahieren
    )
  Else
  HotkeyHilfe =
    (
F1 `t`tHilfe
F2 `t`tDatumsformatmen
F3 `t`tAnsicht wechseln
F4 `t`tDatumsberechnung

Leertaste `tDatumsformat ndern
zus. Shift `tin Gegenrichtung ndern
Eingabetaste `tDatum senden/Beenden
Escape `t`tSchlieen

Pfeil links `t`teinen Tag zurck
Pfeil rechts `teinen Tag weiter

Pfeil auf `t`teine Woche zurck
Pfeil ab `t`teine Woche weiter

Bild auf `t`teinen Monat zurck
Bild ab `t`teinen Monat weiter

Mausrad links `teinen Tag zurck
Mausrad rechts `teinen Tag weiter

Mausrad auf `teine Woche zurck
Mausrad ab `teine Woche weiter

Mittlere Maustaste `tDatumsformat ndern
Doppelklick (li.) `tDatum senden/Beenden
    )
  Gui, +OwnDialogs ; Force the user to close the MsgBox before returning to the main window.
  MsgBox, 262144, Kalender-Tastaturbefehle, %HotkeyHilfe%
Return

About:
  Gui, +OwnDialogs ; Force the user to close the MsgBox before returning to the main window.
  MsgBox, 262208, ber... , %ScriptName%`n`nVersion: %ScriptVersion% (%ScriptDate%)`n`n 2001-2015`, W. Happe
Return

GuiMenu:
  Menu, FormatMenu, Add
  Menu, FormatMenu, Delete ; ohne vorhergehendes Add: Menu nicht vorhanden
  StringGetPos, pos, ADat, -
  If pos >= 0
      StringLeft, ADat, ADat, pos
  FormatTime, Heute0, %ADat%, %F0%
  FormatTime, Heute1, %ADat%, %F1%
  FormatTime, Heute2, %ADat%, %F2%
  FormatTime, Heute3, %ADat%, %F3%
  FormatTime, Heute4, %ADat%, %F4%
  FormatTime, Heute5, %ADat%, %F5%
  FormatTime, Heute6, %ADat%, %F6%
  FormatTime, Heute7, %ADat%, %F7%
  If F != %F0%
      Menu, FormatMenu, Add, %Heute0%, Format0
  If F != %F1%
      Menu, FormatMenu, Add, %Heute1%, Format1
  If F != %F2%
      Menu, FormatMenu, Add, %Heute2%, Format2
  If F != %F3%
      Menu, FormatMenu, Add, %Heute3%, Format3
  If F != %F4%
      Menu, FormatMenu, Add, %Heute4%, Format4
  If F != %F5%
      Menu, FormatMenu, Add, %Heute5%, Format5
  If F != %F6%
      Menu, FormatMenu, Add, %Heute6%, Format6
  If F != %F7%
      Menu, FormatMenu, Add, %Heute6%, Format7
  If MonthView = 1
      Menu, FormatMenu, Show, 175, 250
  Else If MonthView = 3
      Menu, FormatMenu, Show, 175, 540
Return

Format0:
  F = %F0%
  Gosub, UpdateFormat
Return

Format1:
  F = %F1%
  Gosub, UpdateFormat
Return

Format2:
  F = %F2%
  Gosub, UpdateFormat
Return

Format3:
  F = %F3%
  Gosub, UpdateFormat
Return

Format4:
  F = %F4%
  Gosub, UpdateFormat
Return

Format5:
  F = %F5%
  Gosub, UpdateFormat
Return

Format6:
  F = %F6%
  Gosub, UpdateFormat
Return

Format7:
  F = %F7%
  Gosub, UpdateFormat
Return

UpdateFormat:
  FormatTime, ADat1, %VonBis1%, %F%
  FormatTime, ADat2, %VonBis2%, %F%
  If (ADat1 = ADat2)
    BDat := ADat1
  Else
    {
    compareVar := VonBis1
    EnvSub, compareVar, %VonBis2%, Days
    If (compareVar > 0)
      {
      temp := ADat1
      ADat1 := ADat2
      ADat2 := temp
      }
    FormatTime, numMonth1, %VonBis1%, M  ; Month without leading zero (1  12)
    FormatTime, numMonth2, %VonBis2%, M
    Loop { ; A_Index contains 1 the first time the loop's body is executed
     If (SubStr(ADat1, 0) = SubStr(ADat2, (A_Index - 1) * -1, 1) and StrLen(ADat1) > 2)
        {
        delChar := SubStr(ADat1, 0) ; => 0 extracts the last character
        If !(numMonth1 != numMonth2 and RegExMatch(ADat1, "[i|uar|ber]$"))
          StringTrimRight, ADat1, ADat1, 1
        }
      Else
        {
        If (delChar = ".") ; falls Punkt entfernt wurde
          ADat1 = %ADat1%. ; muss er wieder hinzugefgt werden
        Break
        }
      }
    BDat := RegExMatch(ADat1, "^[\d.]+$") ? ADat1 "-" ADat2 :  ADat1 " - " ADat2
    }
  GuiControl,, Button4, % TrimToWidth(BDat, 170) ; ControlSetText, Button4, %BDat
Return


MCalRoutine:
  If (! NoMouseClick)
    {
      If (A_GuiEvent = Normal) OR (A_GuiEvent = 2)
          Return
      If (A_GuiEvent = 1) && ((A_TickCount - TheTimeBefore) < DllCall("GetDoubleClickTime")) && (ADat = ADatOld)
        {
          DoubleClick = 1
        }
      Else If (A_GuiEvent = 1)
        {
          ADatOld := ADat
          TheTimeBefore := A_TickCount
        }
    }
  StringSplit, VonBis, ADat, -
  GoSub, UpdateFormat
  If (DoubleClick)
      GoSub, CloseCalendar
  NoMouseClick =
Return

CloseCalendar:
  WinGetPos, xPos, yPos,,, ahk_id %hw_Kalender%
  OnMessage(0x133, "") ; WM_CTLCOLOREDIT0
  OnMessage(0x200, "") ; WM_MOUSEMOVE0
 Gui, Destroy ; dadurch sollte bereits das richtige Fenster aktiv ewrden
  WinActivate, % "ahk_id " LastActiveWindowID() ; im Normalfall eh aktiv
  Send, %BDat%
  Clipboard = %BDat%
  Gosub, AppExit
Return

CloseApp: ; TrayMenu
  MinToTray := 0 ; wird nicht gespeichert
GUIEscape:
GUIClose:
  OnMessage(0x133, "") ; WM_CTLCOLOREDIT0
  OnMessage(0x200, "") ; WM_MOUSEMOVE0
  WinGetPos, xPos, yPos,,, ahk_id %hw_Kalender%
  GoSub, AppExit ; Fensterposition speichern
  Gui, Destroy ; nachdem Position gepseichert wurde
Return

AppExit:
  IniWrite, %xPos%, Kalender.ini, Kalender, WinPosX
  IniWrite, %yPos%, Kalender.ini, Kalender, WinPosY
  IniWrite, %datFormat%, Kalender.ini, Kalender, DatFormat
  IniWrite, %MonthView%, Kalender.ini, Kalender, MonthView
  If !MinToTray
    ExitApp
Return

;================ Einstellungen ============================
Options:
  If (MinToTray && KalenderHotkey <> "")
    Hotkey, %KalenderHotkey%, Off
  IfWinExist, ahk_id %hw_Kalender%
    {
    Gui, 2:+owner1  ; Make the main window (Gui #1) the owner of the "about box" (Gui #2). Gui,2: Destroy
    Gui +Disabled  ; Disable main window.
    }
  Gui, 2: +OwnDialogs -SysMenu
  EinAus := ColorScheme = 1 ? 1 : 0
  WinKey := InStr(SubStr(KalenderHotkey, 1, -1), "#") ? 1 : 0
  TempHotkey := WinKey ? RegExReplace(KalenderHotkey,"#","","",1) : KalenderHotkey
  Gui, 2: Add, Radio, x10 y10 vColorScheme Checked%EinAus%, grn
  EinAus := ColorScheme = 2 ? 1 : 0
  Gui, 2: Add, Radio, xp+54 yp Checked%EinAus%, blau
  EinAus := ColorScheme = 3 ? 1 : 0
  Gui, 2: Add, Radio, xp+54 yp Checked%EinAus%, gelb
  EinAus := ColorScheme = 4 ? 1 : 0
  Gui, 2: Add, Radio, xp+53 yp Checked%EinAus%, grau
  Gui, 2: Add, Text, 0x1000 xm yp+25 w200 h2
  TempMinToTray := MinToTray
  Gui, 2: Add, CheckBox, x10 yp+11 vTempMinToTray -Wrap Checked%MinToTray% gOptionControl, Ins Tray minimieren, statt zu schliessen
  Gui, 2: Add, Text, x10 yp+25 vTxtMinToTray, Hotkey: ; (Anzeigen/Verbergen):  ; yp+15
  Gui, 2: Add, Hotkey, x53 yp-4 w90 vTempHotkey Limit179 , %TempHotkey%
  Gui, 2: Add, CheckBox, x149 yp+4 vWinKey -Wrap Checked%WinKey%, zus. Win.
  Gui, 2: Add, Text, 0x1000 xm yp+25 w200 h2
  GoSub, OptionControl
  Gui, 2: Add, Button, x55 yp+11 w75 Default -TabStop, OK
  Gui, 2: Add, Button, xp+80 yp w75 -TabStop, Abbrechen
  Gui, 2: Show,, Einstellungen
Return
; ------------------------------------------------------------------------------
OptionControl:
  Gui, 2: Submit, NoHide  ; Saves the user's input
  If (QuickKey)
    GuiControl, 2: Disable, TempMinToTray
  If (!QuickKey && TempMinToTray = 1)
    {
    GuiControl, 2: Enable, TxtMinToTray
    GuiControl, 2: Enable, TempHotkey
    GuiControl, 2: Enable, WinKey
    }
  Else
    {
    GuiControl, 2: Disable, TxtMinToTray
    GuiControl, 2: Disable, TempHotkey
    GuiControl, 2: Disable, WinKey
    }
Return

2ButtonOK:
  Gui, 2: Submit
  Gui, 1: -Disabled  ; Re-enable the main window (must be done prior to the next step).
  Gui, 2: Destroy
  IniWrite, %ColorScheme%, Kalender.ini, Kalender, ColorScheme
  IniWrite, %TempMinToTray%, Kalender.ini, Kalender, MinToTray
  KalenderHotkey := WinKey ? "#" . TempHotkey : TempHotkey  ; WinKey hinzufgen
  IniWrite, %KalenderHotkey%, Kalender.ini, Kalender, KalenderHotkey
  GoSub, KalenderReload
  WinActivate, ahk_id %hw_Kalender% ; wird nicht erreicht
Return

KalenderReload:
  WinGetPos, xPos, yPos,,, ahk_id %hw_Kalender%
  IniWrite, %xPos%, Kalender.ini, Kalender, WinPosX
  IniWrite, %yPos%, Kalender.ini, Kalender, WinPosY
  IniWrite, %datFormat%, Kalender.ini, Kalender, DatFormat
  IniWrite, %MonthView%, Kalender.ini, Kalender, MonthView
  Reload
  Sleep, 1000
Return ; wird nicht erreicht
; ------------------------------------------------------------------------------
2GuiEscape:
2GuiClose:
2ButtonAbbrechen:
  Gui, 1: -Disabled  ; Re-enable the main window (must be done prior to the next step).
  Gui, 2: Destroy
  WinActivate, ahk_id %hw_Kalender%
  If (MinToTray && KalenderHotkey <> "")
    Hotkey, %KalenderHotkey%, On
Return

;---------------------------- Tagesdifferenz ----------------------

CalcSelection:
  Gui, Submit, NoHide
  GoSub, sub_group_%groupIndex%
Return

sub_group_1:
  GuiControl,, strErgebnis, Unterschied in Tagen:
  GuiControl, Hide, diffDays
  GuiControl, Hide, diffDays_ud
  GuiControl, Show, endDate
  GoSub, sub_twoDates
Return

sub_group_2:
  GuiControl,, strErgebnis, Errechnetes Datum:
  GuiControl, Hide, endDate
  GuiControl, Show, diffDays
  GuiControl, Show, diffDays_ud
  GoSub, sub_diffDays
Return

sub_twoDates:
  GuiControlGet, startDate
  GuiControlGet, endDate
  diffString2 := AGE(startDate, endDate)
  endDate -= startDate, Days
  GuiControl,, diffDays, % ThousandsSep(endDate)
  diffString1 := endDate = 1 ? endDate " Tag" : endDate " Tage"
  diffString2 := Abs(endDate) > 6 ? diffString2 : ""
  GuiControl,, statusRes, %diffString1%`n%diffString2%
Return

sub_diffDays:
  IfEqual, groupIndex, 1, Return
  GuiControlGet, startDate
  GuiControlGet, diffDays
  StringReplace, diffDays, diffDays, .,, All
  firstDate := startDate
  startDate += diffDays, Days ; liefert  Ergebnis, wenn diese vor 1601 oder nach 9999 liegt
  If (startDate = "" or diffDays > 999999 or !RegExMatch(diffDays, "^[-]?[\d]*$")) ; Zahl & Minus
    { ; die einzig mgliche Konstellation: diffDays liegt als Minuswert vor (bis -182.255)
    GuiControl,, diffDays ; % ThousandsSep(diffDays + 1) ; Gegenteil (-1) wird  bentigt!
    Return
    }
  GuiControl,, endDate, %startDate%
  diffString2 := AGE(firstDate, startDate)
  diffString2 := Abs(diffDays) > 6 ? diffString2 : ""
  FormatTime, firstDate, %startDate%, dddd`, 'der' d. MMMM yyyy
  GuiControl,, statusRes, %firstDate%`n%diffString2%
Return

;======================= Kalender-Functions =======================

TrimToWidth(txtToTrim, widthInPx) {
  Loop, 9
    {
    If GetTextSize(txtToTrim, "9", "MS Sans Serif") < widthInPx
      Break
    Else
      txtToTrim := RegExReplace(txtToTrim, "\s[^\s]+$", "...")
    }
    return txtToTrim
  }

AGE(B,E) {  ; SKAN, http://www.autohotkey.com/forum/topic21456.html
  X := E
  X -= B,s ; seconds difference
  If X < 0 ; change startDate with endDate
    {
      X := B
      B := E
      E := X
    }
  Y:=0, M:=0, D:=0,  Feb29 := SubStr(B,1,4) . "0229235959"
    dYear := B > Feb29 ? 365 * 86400 : LDOY(B) * 86400
    If DateDiff(B,E) >= dYear
       B:=DateAdd(B,dYear)  ,   Y:=Y+1
    Loop   {
              sYear := LDOY(B) * 86400
              If DateDiff(B,E) >= sYear
                 B:=DateAdd(B,sYear)  ,   Y:=Y+1
              Else Break
  } Loop   {
              sMonth := LDOM(B) * 86400
              If DateDiff(B,E) >= sMonth
                 B:=DateAdd(B,sMonth) ,   M:=M+1
              Else Break
  } Loop   {
              If DateDiff(B,E) >= 86400
                 B:=DateAdd(B,86400)  ,   D:=D+1
              Else Break
           }
  W := D > 6 ? Floor(D/7) : ""
  D := W ? D - W * 7 : D
  Y := Abs(Y) > 1 ? Y " Jahre"  : Abs(Y) < 1 ? "" : Y " Jahr"
  M := Abs(M) > 1 ? M " Monate" : Abs(M) < 1 ? "" : M " Monat"
  W := Abs(W) > 1 ? W " Wochen" : Abs(W) < 1 ? "" : W " Woche"
  D := Abs(D) > 1 ? D " Tage"   : Abs(D) < 1 ? "" : D " Tag"
  String = (%Y%`, %M%`, %W%`, %D%)
  String := RegExReplace(String, "(?<=\(), |, (?=,)|, (?=\))")
  String := RegExReplace(String, "^\(\K, ") ; "(?<=\(), " ; nicht in oberer Zeile
  Return String
  }

DateDIFF(B, E, U="S") { ; EnvSub
  E-=%B%,%U%
  Return E
  }

DateADD(Dt, V, U="S") { ; EnvAdd
  Dt+=%V%,%U%
  Return Dt
  }

LDOY( Dt ) { ; Last Day of Year
  Year:=SubStr(Dt,1,4), Days:=Year+1
  Days-=%Year%,D
  Return Days
  }

LDOM( Dt ) { ; Last Day of Month
  M1:=SubStr(Dt,1,6), M2:=M1
  M2+=31,D
  M2:=SubStr(M2,1,6)
  M2-=%M1%,D
  Return M2
  }

ThousandsSep(x, s=".") {  ; http://www.autohotkey.com/forum/topic54149.html
  Return RegExReplace(x, "(?(?<=\.)(*COMMIT)(*FAIL))\d(?=(\d{3})+(\D|$))", "$0" s)
  }

WM_MOUSEMOVE0() {
    static CurrControl, PrevControl, _TT  ; _TT is kept blank for use by the ToolTip command below.
    CurrControl := A_GuiControl
    If (CurrControl <> PrevControl and not InStr(CurrControl, " ") or InStr(CurrControl, "\"))
    {
        ToolTip  ; Turn off any previous tooltip.
        SetTimer, DisplayToolTip, 1000
        PrevControl := CurrControl
    }
    Return

    DisplayToolTip:
    SetTimer, DisplayToolTip, Off
    If (CurrControl = "startDate" || CurrControl = "endDate" || CurrControl = "diffDays")
      ToolTip % %CurrControl%_TT
    SetTimer, RemoveToolTip, 2000
    Return

    RemoveToolTip:
    SetTimer, RemoveToolTip, Off
    ToolTip
    Return
  }

WM_CTLCOLOREDIT0(wParam, lParam) {
  Global ResultEditID, LightMonthCal, Ptr ; , TextColor
  Critical
  If (lParam = ResultEditID)
    {
    DllCall("SetBkColor", Ptr, wParam, UInt, LightMonthCal)
    Return (DllCall("CreateSolidBrush", UInt, LightMonthCal))
    }
  }

GetTextSize(pStr, pSize, pFont, pWeight = 400, pHeight = false) {
  Gui, 55: Font, s%pSize% w%pWeight%, %pFont%
  Gui, 55: Add, Text, R1, %pStr%
  GuiControlGet T, 55: Pos, Static1
  Gui, 55: Destroy
  Return pHeight ? TW "," TH : TW
  }

LastActiveWindowID() { ;Global hw_Kalender
  WS_EX_TOPMOST = 0x8
  WS_EX_CONTROLPARENT = 0x10000
  WS_EX_APPWINDOW = 0x40000 ; provides a taskbar button for a window that would otherwise lack one
  WS_EX_TOOLWINDOW = 0x80 ; removes/adds the window from the alt-tab list
  GW_OWNER = 4
  DetectHiddenWindows, Off ; makes DllCall("IsWindowVisible") unnecessary
  WinGet, windowList, List,,, Host fr die Windows Shell-Oberflche ; gather a list of running programs
  Loop, %windowList%
    { ;IfEqual, windowList%A_Index%, %hw_Kalender%, Continue
    IfEqual, windowList%A_Index%, %A_ScriptHwnd%, Continue
    ownerID := windowID := windowList%A_Index%
    Loop {
      ownerID := Decimal_to_Hex( DllCall("GetWindow", "UInt", ownerID, "UInt", GW_OWNER))
    } Until !Decimal_to_Hex( DllCall("GetWindow", "UInt", ownerID, "UInt", GW_OWNER))
    ownerID := ownerID ? ownerID : windowID
    If (Decimal_to_Hex(DllCall("GetLastActivePopup", "UInt", ownerID)) = windowID)
      {
      WinGet, es, ExStyle, ahk_id %windowID%
      WinGetTitle, title, ahk_id %windowID%
      WinGetClass, class, ahk_id %windowID%
      If !((es & WS_EX_TOOLWINDOW) && !(es & WS_EX_APPWINDOW) || !title || !class)
        { ;WinGetTitle, title, ahk_id %windowID% ; ; MsgBox % title
        Return windowID ; Break
        }
      }
    }
  }

Decimal_to_Hex(var) {
  SetFormat, IntegerFast, H
  var += 0  ; Sets Var (which previously contained 11) to be 0xb
  var .= "" ; Necessary due to the "fast" mode.
  SetFormat, Integer, D
  return var
  }
